//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* add more methods
*/

package starship2d;


public class Vector2
{
	// VARIABLES
	public float x;
	public float y;

	
	// FUNCTIONS
	Vector2()
	{
		x = 0;
		y = 0;
	}
	
	Vector2(float vx, float vy)
	{
		x = vx;
		y = vy;
	}
	
	Vector2(int vx, int vy)
	{
		x = (float) vx;
		y = (float) vy;
	}
	
	Vector2(double vx, double vy)
	{
		x = (float) vx;
		y = (float) vy;
	}
	
	Vector2(Vector2 v)
	{
		x = v.x;
		y = v.y;
	}
	
	public float magnitude()
	{
		return (float) Math.sqrt(x*x + y*y);
	}

	public void normalize()
	{
		float m = magnitude();

		x /= m;
		y /= m;
	}

	public void scale(float s)
	{
		x *= s;
		y *= s;
	}

	public String toString()
	{
		return "(" + x + ", " + y + ")";
	}
} // end Vector2
