//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* add more methods
*/

package starship2d;


public class Vector3
{
	// VARIABLES
	public float x;
	public float y;
	public float z;

	
	// FUNCTIONS
	Vector3()
	{
		x = 0;
		y = 0;
		z = 0;
	}
	
	Vector3(float vx, float vy, float vz)
	{
		x = vx;
		y = vy;
		z = vz;
	}
	
	Vector3(int vx, int vy, int vz)
	{
		x = (float) vx;
		y = (float) vy;
		z = (float) vz;
	}
	
	Vector3(double vx, double vy, double vz)
	{
		x = (float) vx;
		y = (float) vy;
		z = (float) vz;
	}
	
	Vector3(Vector3 v)
	{
		x = v.x;
		y = v.y;
		x = v.z;
	}
	
	public float magnitude()
	{
		return (float) Math.sqrt(x*x + y*y + z*z);
	}
	
} // end Vector2
